      PROGRAM  P25
C
C     EACH STEP TIMED SEPARATELY.
C     I-LOOP INSIDE (FOR COMPILERS WHICH DO NOT EXCHANGE LOOPS).
C     V1, 92/11/26.
C
      IMPLICIT    REAL*8  (A-H,O-Z)
      PARAMETER   (ND = 1600, NIN = 5, NOUT = 6)
      DIMENSION   A(ND,ND), B(ND,ND), C(ND,ND)
C
      WRITE (NOUT,200)
      READ (NIN,100) N
      WRITE (NOUT,201) ND, N
      CALL TEMPD(T0, T1, TD, NOUT, .TRUE.)
      DO  12  J = 1,N
          DO  10  I = 1,N
              A(I,J) = (J * I)
              B(I,J) = (J + I)
   10     CONTINUE
   12 CONTINUE
      CALL TEMPD(T1, T2, TD, NOUT, .TRUE.)
      DO  20  J = 1,N
          DO  18  I = 1,N
              C(I,J) = 0.D0
   18     CONTINUE
   20 CONTINUE
      CALL TEMPD(T2, T3, TD, NOUT, .TRUE.)
      DO  26  J = 1,N
          DO  24  K = 1,N
              DO  22  I = 1,N
                  C(I,J) = C(I,J) + A(I,K) * B(K,J)
   22         CONTINUE
   24     CONTINUE
   26 CONTINUE
      CALL TEMPD(T3, T4, TD, NOUT, .TRUE.)
      WRITE (NOUT,202) N, ND, ((C(I,J), J = 1,4), I = 1,4)
C
  100 FORMAT (I4)
  200 FORMAT (1H , 8HP25 V1  )
  201 FORMAT (1H , 8HND, N   , 2I8)
  202 FORMAT (1H , 2I8, /, (1H , 4E16.8))
      END
