      SUBROUTINE    TEMPD(TOLD, TNEW, TDIF, NOUT, LPR)
      INTEGER       NOUT
      REAL*8        TOLD, TNEW, TDIF
      LOGICAL       LPR
C
C     SGI PCL TIMING ROUTINE, USING ETIME.
C     ETIME REPORTS ELAPSED EXECUTION TIME (USER, SYSTEM) SINCE THE
C     LAST CALL TO ITSELF; THEREFORE THIS PROGRAM WORKS OK ONLY IF THERE
C     ARE NO OTHER CALLS TO ETIME EXCEPT FROM THIS PROGRAM.
C     (ETIME MAY NOT MEASURE THE CPU TIME ITSELF.)
C
C     INPUT:  TOLD, NOUT, LPR (ALL UNCHANGED).
C     OUTPUT: TNEW, TDIF.
C
      LOGICAL   INIT, TEST
      REAL*4    ETIME, TARRAY 
      DIMENSION TARRAY(2)
      REAL*8    TSUM, SDIF
      DATA      INIT / .TRUE. /, TEST / .FALSE. /
C
      IF (INIT) THEN
          WRITE (NOUT,2000)
          TSUM = ETIME(TARRAY)
          TDIF = TARRAY(1)
          TNEW = TOLD + TDIF
          SDIF = TARRAY(2)
          INIT = .FALSE.
          IF (TEST) WRITE (NOUT,2200) TSUM, TNEW, TDIF, TOLD, SDIF
          RETURN
      ENDIF
      TSUM = ETIME(TARRAY)
      TDIF = TARRAY(1)
      TNEW = TOLD + TDIF
      SDIF = TARRAY(2)
      IF (TEST) WRITE (NOUT,2200) TSUM, TNEW, TDIF, TOLD, SDIF
      IF (LPR) WRITE (NOUT,2100) TNEW, TDIF, TOLD, SDIF
      RETURN
C
 2000 FORMAT (' -TEMPD- 3.0, 95/12/20. SGI PC TIMING ROUTINE.') 
 2100 FORMAT ('   TIME', F12.2,
     A                  '     DIF', F12.2,
     B                  '     REF', F12.2,
     C                  ' DIF SYS', F12.2)
 2200 FORMAT (' SUM USER DIF OLD SYS', 5F8.2)
      END
